# com.bea.wlw.netui.pageflow
PageFlowActionServlet Class

public class PageFlowActionServlet
extends `AutoRegisterActionServlet`

ActionServlet that dynamically registers modules based on naming/location conventions for Struts configuration files that are generated by the Page Flow compiler. These files are located in /WEB-INF/.pageflow-struts-generated, and are named jpf-struts-config-module-name.xml. The user may specify additional `PageFlowActionServlet.DefaultModuleConfigLocator``` classes in web.xml, using the "moduleConfigLocators" init-parameter; this allows the user to define other patterns for auto-registered Struts modules.

Hierarchy
  `Object`
  `GenericServlet`
  `HttpServlet`
  `ActionServlet`
  `AutoRegisterActionServlet`
  `PageFlowActionServlet`

All Implemented Interfaces
  `Serializable`, `Servlet`, `ServletConfig`

Direct Known Subclasses
  `DynamicSubappActionServlet`

## Nested Class Summary

`public static class` | `PageFlowActionServlet.DefaultModuleConfigLocator` Default ModuleConfigLocator that looks for Struts module configuration files according to the pattern "/WEB-INF/.pageflow-struts-generated/jpf-struts-config-<module>".
`protected static class` | `PageFlowActionServlet.LegacyModuleConfigLocator` ModuleConfigLocator that looks for legacy Struts module configuration files according to the pattern "/WEB-INF/jpf-struts-config-<module>".

Nested classes from com.bea.wlw.netui.pageflow`.`AutoRegisterActionServlet``
``AutoRegisterActionServlet.ModuleConfigLocator``

## Field Summary

Fields from com.bea.wlw.netui.pageflow`.`AutoRegisterActionServlet``
``MODULE_CONFIG_LOCATOR_CLASS_ATTR``

Fields from org.apache.struts.action`.`ActionServlet``
`config, configDigester, convertNull, dataSources, debug, internal, internalName, log, processor, registrations, servletMapping, servletName`

## Constructor Summary

PageFlowActionServlet()

## Method Summary

`protected `AutoRegisterActionServlet.ModuleConfigLocator`[]` | `getDefaultModuleConfigLocators`() Get the base list of ModuleConfigLocators, to specify locations for auto-registered Struts modules.
`public `String`` | `getModuleConfPath`(`String` modulePath) Get the webapp-relative path to the Struts module configration file for a given module path.
`public void` | `init`(`ServletConfig` config)
`protected void` | `process`(`HttpServletRequest` request, `HttpServletResponse` response) This override of the base class process() registers a Struts module on the fly if the config file can be found in our standard place (named in our standard way), regardless of whether the module is configured in web.xml.

Methods from `com.bea.wlw.netui.pageflow.`AutoRegisterActionServlet``
``destroy`, `getInitParameter`, `getInitParameterNames`, `getModuleConfig`, `getModuleConfigLocators`, `init`, `registerModule`,`

Methods from `org.apache.struts.action.`ActionServlet``
`destroy, destroyApplications, destroyConfigDigester, destroyDataSources, destroyInternal, destroyModules, doGet, doPost, findDataSource, findFormBean, findForward, findMapping, getApplicationConfig, getDebug, getInternal, getModuleConfig, getRequestProcessor, getResources, init, initApplicationConfig, initApplicationDataSources, initApplicationMessageResources, initApplicationPlugIns, initConfigDigester, initDataSources, initInternal, initModuleConfig, initModuleDataSources, initModuleMessageResources, initModulePlugIns, initOther, initServlet, log, process`

Methods from `javax.servlet.http.`HttpServlet``
`doDelete, doGet, doHead, doOptions, doPost, doPut, doTrace, getLastModified, service, service`

Methods from `javax.servlet.`GenericServlet``
`destroy, getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletInfo, getServletName, init, init, log, log, service`

Methods from class `java.lang.`Object``
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods from interface `javax.servlet.`Servlet``
`destroy, getServletConfig, getServletInfo, init, service`

Methods from interface `javax.servlet.`ServletConfig``
`getInitParameter, getInitParameterNames, getServletContext, getServletName`

## Constructor Detail

### PageFlowActionServlet

    public PageFlowActionServlet()

## Method Detail

### getDefaultModuleConfigLocators() Method

    protected AutoRegisterActionServlet.ModuleConfigLocator[] getDefaultModuleConfigLocators()

Get the base list of ModuleConfigLocators, to specify locations for auto-registered Struts modules. By default, this ActionServlet auto-registers Struts modules whose configuration files are located at "/WEB-INF/.pageflow-struts-generated/jpf-struts-config-<module>". Overriding this method allows alternate locations to be specified. When an unrecognized Struts module is requested, each registered ModuleConfigLocator is queried for a possible path to the configuration file for the module. If the configuration file is found, the module is auto-registered against the file.

Overrides
  `AutoRegisterActionServlet.getDefaultModuleConfigLocators()`

### getModuleConfPath(String) Method

    public String getModuleConfPath(String modulePath)

Get the webapp-relative path to the Struts module configration file for a given module path. By default, this is "/WEB-INF/.pageflow-struts-generated/jpf-struts-config-<module>", but alternate locations can be specified by adding `PageFlowActionServlet.DefaultModuleConfigLocator```s.

Overrides
  `AutoRegisterActionServlet.getModuleConfPath(String)`

#### Parameters

modulePath
  the Struts module path.

#### Returns

a String that is the path to the Struts configuration file, relative to the web application root.

Related Topics

``PageFlowActionServlet.getDefaultModuleConfigLocators()``

### init(ServletConfig) Method

    public void init(ServletConfig config)
         throws ServletException

Overrides
  `AutoRegisterActionServlet.init(ServletConfig)`

#### Exceptions

``ServletException``

### process(HttpServletRequest, HttpServletResponse) Method

    protected void process(HttpServletRequest request,
                           HttpServletResponse response)
         throws IOException, ServletException

Description copied from `AutoRegisterActionServlet.process(HttpServletRequest, HttpServletResponse)`
This override of the base class process() registers a Struts module on the fly if the config file can be found in our standard place (named in our standard way), regardless of whether the module is configured in web.xml.

Overrides
  `AutoRegisterActionServlet.process(HttpServletRequest, HttpServletResponse)`

#### Exceptions

``IOException``
``ServletException``